VisualEditor: Add FlaggedRevs "accept pending revisions" to save dialog
Closed, ResolvedPublic

Description

Alongside the "minor" and "watch" checkboxes in the save dialog, for pages with FlaggedRevs switched on and outstanding unaccepted revisions, add a checkbox to "accept pending revisions".


Version: unspecified
Severity: enhancement
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=50852

bzimport set Reference to bz49699.
Jdforrester-WMF created this task.Via LegacyJun 17 2013, 4:10 PM
Jdforrester-WMF added a comment.Via ConduitJul 6 2013, 9:21 PM
  • Bug 50852 has been marked as a duplicate of this bug. ***
Jalexander added a comment.Via ConduitJul 6 2013, 9:51 PM

Just as an addition to this: I'm not sure if just the checkbox is what is needed. The current work flow has a whole separate page because we need to show the diff involved for the review. I imagine that can be done without going to a new page but either way they should be able to review the diff (and preferably leave a comment like you can in the review page now) before checking any kind of approve box since they become somewhat responsible for those edits.

Risker added a comment.Via ConduitJul 6 2013, 10:06 PM

(In reply to comment #0)

Alongside the "minor" and "watch" checkboxes in the save dialog, for pages
with
FlaggedRevs switched on and outstanding unaccepted revisions, add a checkbox
to
"accept pending revisions".

I don't find that an acceptable solution, because there is a requirement that reviewers actually review the edit they are accepting; they cannot do that if they're just ticking a box.

See https://commons.wikimedia.org/wiki/File:Cropped_edit_source_admin_edit_with_existing_PC.png for what the screen looks like using Edit Source. Note that the diff includes ALL unreviewed changes.

Jdforrester-WMF added a comment.Via ConduitJul 6 2013, 10:17 PM

(In reply to comment #2)

Just as an addition to this: I'm not sure if just the checkbox is what is
needed. The current work flow has a whole separate page because we need to
show the diff involved for the review. I imagine that can be done without
going to a new page but either way they should be able to review the diff
(and preferably leave a comment like you can in the review page now) before
checking any kind of approve box since they become somewhat responsible for
those edits.

Yes, indeed; I was imagining:

  • on load, an alert in the edit notices saying "You will need to accept the outstanding changes before saving" (or whatever the current message is) - possibly with a link to the below?
  • on entering the save dialog, the save button will be disabled with another copy of the "You will need to accept the outstanding changes before saving" text (in the same place as the edit conflict / CAPTCHA / DOM corruption warnings)
  • in the line of buttons ("Save page", "Review your changes") there should be a third button, "Review outstanding changes", which on click pops up the diff of outstanding changes, with a text box for the optional review comment and an "accept these changes" button that takes you back to the save dialog, now with the save button enabled.

Feels a little clunky, though - perhaps we could make the process in-line with the edit summary message?

Krinkle added a comment.Via ConduitJul 16 2013, 8:55 PM

(In reply to comment #4)

(In reply to comment #2)
> Just as an addition to this: I'm not sure if just the checkbox is what is
> needed. The current work flow has a whole separate page because we need to
> show the diff involved for the review. I imagine that can be done without
> going to a new page but either way they should be able to review the diff
> (and preferably leave a comment like you can in the review page now) before
> checking any kind of approve box since they become somewhat responsible for
> those edits.

Yes, indeed; I was imagining:

  • on load, an alert in the edit notices saying "You will need to accept the outstanding changes before saving" (or whatever the current message is) - possibly with a link to the below?
  • on entering the save dialog, the save button will be disabled with another copy of the "You will need to accept the outstanding changes before saving" text (in the same place as the edit conflict / CAPTCHA / DOM corruption warnings)
  • in the line of buttons ("Save page", "Review your changes") there should be a third button, "Review outstanding changes", which on click pops up the diff of outstanding changes, with a text box for the optional review comment and an "accept these changes" button that takes you back to the save dialog, now with the save button enabled.

    Feels a little clunky, though - perhaps we could make the process in-line with the edit summary message?

Since this is going to need to be fully in javascript for VisualEditor, and the interface for this in FlaggedRevisions is already mostly in javascript (a small bit is done server-side through EditPage hooks), I recommend we not duplicate all of this logic and API handling for:

  • "advertise you are reviewing this"
  • API handling "leave comments" "get the diff against the latest stable version"
  • "mark as reviewed"
  • etc.

And instead depend on the logic being in FlaggedRevisions in a re-usable way that we can just call from within VisualEditor.

Ideally they would also make their styling more pretty so that we can actually re-use it. Alternatively they'll have to make the logic re-usable separate from the UI as the current UI is not going to fit in (not just visually foreign to VisualEditor or usable interfaces in general, but also technically due to the DOM structure and layout properties).

Risker added a comment.Via ConduitJul 17 2013, 5:08 PM

(In reply to comment #0)

Alongside the "minor" and "watch" checkboxes in the save dialog, for pages
with
FlaggedRevs switched on and outstanding unaccepted revisions, add a checkbox
to
"accept pending revisions".

I note this has been posted as an enhancement; however, as flagged revisions are applied to *all* pages in article space on certain Wikipedias (de and ru in particular) I'd urge that this be resolved prior to introducing VisualEditor to those projects. For them, the absence of this would be more than the minor inconvenience it is on English Wikipedia, where PC is applied to a very small number of pages and could be switched to semi-protection if really needed.

Jdforrester-WMF added a comment.Via ConduitJul 17 2013, 5:12 PM

(In reply to comment #6)

I note this has been posted as an enhancement; however, as flagged revisions
are applied to *all* pages in article space on certain Wikipedias (de and ru
in particular) I'd urge that this be resolved prior to introducing VisualEditor
to those projects. For them, the absence of this would be more than the minor
inconvenience it is on English Wikipedia, where PC is applied to a very small
number of pages and could be switched to semi-protection if really needed.

Absolutely.

Jdforrester-WMF added a comment.Via ConduitJul 24 2013, 6:01 AM
  • Bug 51833 has been marked as a duplicate of this bug. ***
gerritbot added a comment.Via ConduitJul 24 2013, 6:46 AM

Change 75555 had a related patch set uploaded by Catrope:
Render check boxes from EditPage

https://gerrit.wikimedia.org/r/75555

gerritbot added a comment.Via ConduitJul 24 2013, 7:07 AM

Change 75555 merged by jenkins-bot:
Render check boxes from EditPage

https://gerrit.wikimedia.org/r/75555

Jdforrester-WMF added a comment.Via ConduitJul 24 2013, 7:07 AM

Merged and will get deployed in a few hours' time.

Add Comment

Column Prototype
This is a very early prototype of a persistent column. It is not expected to work yet, and leaving it open will activate other new features which will break things. Press "\" (backslash) on your keyboard to close it now.